## stress-ng 0.10.07

=== Makefile ===
#
# Copyright (C) 2013-2019 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.10.07
#
# Codename "systematic system smasher"
#

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
CFLAGS += -Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
endif

GREP = grep
#
# SunOS requires special grep for -e support
#
KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Check for KFreeBSD
#
ifeq ($(KERNEL),GNU/kFreeBSD)
CFLAGS += -D__FreeBSD_Kernel__
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
LDFLAGS += -static -z muldefs
CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aio-linux.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cap.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-file-ioctl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-fork.c \
	stress-fp-error.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-handle.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-idle-page.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-iosync.c \
	stress-ipsec-mb.c \
	stress-itimer.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-lease.c \
	stress-link.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-longjmp.c \
	stress-loop.c \
	stress-lsearch.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-matrix-3d.c \
	stress-mcontend.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-mincore.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mlockmany.c \
	stress-mmap.c \
	stress-mmapaddr.c \
	stress-mmapfixed.c \
	stress-mmapfork.c \
	stress-mmapmany.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-mq.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-netlink-task.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-personality.c \
	stress-physpage.c \
	stress-pidfd.c \
	stress-pipe.c \
	stress-pkey.c \
	stress-poll.c \
	stress-prctl.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-radixsort.c \
	stress-ramfs.c \
	stress-rawdev.c \
	stress-rawsock.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-remap-file-pages.c \
	stress-rename.c \
	stress-resources.c \
	stress-revio.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-set.c \
	stress-shellsort.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigio.c \
	stress-sigpending.c \
	stress-sigpipe.c \
	stress-sigq.c \
	stress-sigrt.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sleep.c \
	stress-socket.c \
	stress-socket-diag.c \
	stress-socket-fd.c \
	stress-socketpair.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-sysbadaddr.c \
	stress-sysinfo.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-tree.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-unshare.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-utime.c \
	stress-vdso.c \
	stress-vecmath.c \
	stress-vforkmany.c \
	stress-vm.c \
	stress-vm-addr.c \
	stress-vm-rw.c \
	stress-vm-segv.c \
	stress-vm-splice.c \
	stress-wait.c \
	stress-watchdog.c \
	stress-wcstr.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \

#
# Stress core
#
CORE_SRC = \
	core-affinity.c \
	core-cache.c \
	core-cpu.c \
	core-helper.c \
	core-ignite-cpu.c \
	core-io-priority.c \
	core-job.c \
	core-limit.c \
	core-log.c \
	core-madvise.c \
	core-mincore.c \
	core-mlock.c \
	core-mmap.c \
	core-mounts.c \
	core-mwc.c \
	core-net.c \
	core-out-of-memory.c \
	core-parse-opts.c \
	core-perf.c \
	core-sched.c \
	core-setting.c \
	core-shim.c \
	core-thermal-zone.c \
	core-time.c \
	core-thrash.c \
	stress-ng.c

SRC = $(STRESS_SRC) $(CORE_SRC)
OBJS = $(SRC:.c=.o)

APPARMOR_PARSER=/sbin/apparmor_parser

LIB_APPARMOR := -lapparmor
LIB_BSD := -lbsd
LIB_Z := -lz
LIB_CRYPT := -lcrypt
LIB_RT := -lrt
LIB_PTHREAD := -lpthread
LIB_AIO = -laio
LIB_SCTP = -lsctp
LIB_DL = -ldl

#
#  Load in and set flags based on config
#
-include config
CFLAGS += $(CONFIG_CFLAGS)
LDFLAGS += $(CONFIG_LDFLAGS)
OBJS += $(CONFIG_OBJS)

all:
ifneq ("$(wildcard config)","")
	$(MAKE) makeconfig
endif
	$(MAKE) stress-ng

.SUFFIXES: .c .o

.o: stress-ng.h Makefile

.c.o: stress-ng.h Makefile $(SRC)
	@echo "CC $<"
	@$(CC) $(CFLAGS) -c -o $@ $<

stress-ng: $(OBJS)
	@echo "LD $@"
	@$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -o $@
	@sync

makeconfig:
	@if [ ! -s config ]; then \
		STATIC=$(STATIC) $(MAKE) -f Makefile.config; \
	fi

#
#  generate apparmor data using minimal core utils tools from apparmor
#  parser output
#
apparmor-data.o: usr.bin.pulseaudio.eg
	@$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin
	@echo "#include <stddef.h>" > apparmor-data.c
	@echo "char g_apparmor_data[]= { " >> apparmor-data.c
	@od -tx1 -An -v < apparmor-data.bin | \
		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
		sed '$$ s/.$$//' >> apparmor-data.c
	@echo "};" >> apparmor-data.c
	@echo "const size_t g_apparmor_data_len = sizeof(g_apparmor_data);" >> apparmor-data.c
	@echo "CC $<"
	@$(CC) -c apparmor-data.c -o apparmor-data.o
	@rm -rf apparmor-data.c apparmor-data.bin

#
#  extract the PER_* personality enums
#
personality.h:
	@$(CPP) core-personality.c | $(GREP) -e "PER_[A-Z0-9]* =.*," | cut -d "=" -f 1 \
	| sed "s/.$$/,/" > personality.h

stress-personality.c: personality.h

core-perf.o: core-perf.c core-perf-event.c
	@$(CC) $(CFLAGS) -E core-perf-event.c | grep "PERF_COUNT" | sed 's/,/ /' | \
	awk {'print "#define _SNG_" $$1 " (1)"'} > core-perf-event.h
	@echo CC $<
	@$(CC) $(CFLAGS) -c -o $@ $<

stress-vecmath.o: stress-vecmath.c
	@echo CC $<
	@$(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
	@touch stress-ng.c

$(OBJS): stress-ng.h Makefile

stress-ng.1.gz: stress-ng.1
	gzip -c $< > $@

.PHONY: dist
dist:
	rm -rf stress-ng-$(VERSION)
	mkdir stress-ng-$(VERSION)
	cp -rp Makefile Makefile.config $(SRC) stress-ng.h stress-ng.1 \
		core-personality.c COPYING syscalls.txt mascot README \
		README.Android test snap config TODO \
		core-perf-event.c usr.bin.pulseaudio.eg stress-version.h \
		bash-completion example-jobs .travis.yml kernel-coverage.sh \
		stress-ng-$(VERSION)
	tar -Jcf stress-ng-$(VERSION).tar.xz stress-ng-$(VERSION)
	rm -rf stress-ng-$(VERSION)

.PHONY: pdf
pdf:
	man -t ./stress-ng.1 | ps2pdf - > stress-ng.pdf


.PHONY: clean
clean:
	@rm -f stress-ng $(OBJS) stress-ng.1.gz stress-ng.pdf
	@rm -f stress-ng-$(VERSION).tar.xz
	@rm -f personality.h
	@rm -f perf-event.h
	@rm -f apparmor-data.bin
	@rm -f *.o
	@:> config

.PHONY: fast-test-all
fast-test-all: all
	STRESS_NG=./stress-ng debian/tests/fast-test-all

.PHONY: slow-test-all
slow-test-all: all
	./stress-ng --seq 0 -t 15 --pathological --verbose --times --tz --metrics

.PHONY: install
install: stress-ng stress-ng.1.gz
	mkdir -p ${DESTDIR}${BINDIR}
	cp stress-ng ${DESTDIR}${BINDIR}
	mkdir -p ${DESTDIR}${MANDIR}
	cp stress-ng.1.gz ${DESTDIR}${MANDIR}
	mkdir -p ${DESTDIR}${JOBDIR}
	cp -rp example-jobs/*.job ${DESTDIR}${JOBDIR}
	mkdir -p ${DESTDIR}${BASHDIR}
	cp bash-completion/stress-ng ${DESTDIR}${BASHDIR}

=== debian/changelog ===
stress-ng (0.10.07-1ubuntu4) eoan; urgency=medium

  * Ensure --aggressive mode terminates early (LP: #1858858)
    Add a waitpid NOHANG wait on each child process and if we get ESRCH
    on all the child pids we can terminate the loop early.

 -- Colin King <colin.king@canonical.com>  Mon, 24 Feb 2020 11:14:21 +0000

stress-ng (0.10.07-1ubuntu3) eoan; urgency=medium
 
  * Fix --timer-slack from consuming the following arg (LP: #1853832)
    Currently the timer slack option eats the next argument, causing
    missing argument parsing behaviour on the command line.
  * Fix mwc8() being reset when using mwc1() (LP: #1855851)
    Fic Psuedo-random 8 bit numbers from mwc8() accidentally
    being zero'd when mwc1() is called.

 -- Colin King <colin.king@canonical.com>  Tue, 10 Dec 2019 09:32:11 +0000

stress-ng (0.10.07-1ubuntu2) eoan; urgency=medium

  * d/p/0005-stress-af-alg-handle-bind-ETIMEDOUT-failures.patch:
    retry bind() on ETIMEDOUT in case the requested module just
    gets loaded by another stress-af-alg worker. (LP: #1851553)

 -- Mauricio Faria de Oliveira <mfo@canonical.com>  Wed, 06 Nov 2019 17:03:40 -0300

stress-ng (0.10.07-1ubuntu1) eoan; urgency=medium

  * stress-stack: fix segfaults when handling signals (LP: #1851316)
    requres upstream fix and prerequisite patches:
    - 10ffe40579c5 stress-stack: return error code in child using
                   _exit() and not return
    - ef18c524df48 stress-stack: don't throw a fatal error when
                   sigaltstack fails
    - 6245e5f62eae stress-stack: check for ENOMEM fork failure and retry
    - 8fb67daea592 stress-stack: setup alternative stack in child only 

 -- Colin King <colin.king@canonical.com>  Wed, 6 Oct 2019 09:02:01 +0000

stress-ng (0.10.07-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove smatchify script, we now use other tools to static
    analyse stress-ng
  * core-helper: add sanity check if ttyname returns NULL to avoid
    null pointer dereferencing
  * stress-fp-error: fix checks for NaN and Inf (LP: #1846216)
  * Don't show utf8 chars on dump consoles (LP: #1846196)
  * stress-clone: make child process larger to make it more
    OOM-able (LP: #1845948)
  * core-out-of-memory: open and close proc interface after each write
  * Add autobuild detection of getsid() for better portability
  * stress-ng.h: only use x86 target clones for x86 arches
  * stress-rdrand: unroll loop x 4 more times for more throughput
  * inline the __keep_stressing function, reduce call overhead
    for more throughput
  * stress-stack: make alternative signal stack privately
    mapped (LP: #1845464)

 -- Colin King <colin.king@canonical.com>  Tue, 1 Oct 2019 16:39:52 +0100

stress-ng (0.10.06-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-mcontend: ensure mmap'd file is sync'd with zero
    data (LP: #1845011)
  * stress-rmap: don't make fallocate failures a rmap test
    failure (LP: #1845005)
  * stress-shm: fork and exit a child to exercise shm dup and
    removal
  * stress-ng: fix jobfile with classes (LP: #1706970)
  * stress-procfs: don't randomly read pci proc info on ARM64
  * stress-procfs: remove bad buffer test, it's not portable
  * stress-sysfs: rename MAX_READ_THREADS to MAX_SYSFS_THREADS
  * stress-sysfs: remove bad address reads, these fault on ARM64
  * stress-procfs: rename MAX_READ_THREADS to MAX_PROCFS_THREADS
  * stress-inode-flags: move open/close to controlling process
  * stress-sig: fix spelling mistake "siqqueue" -> "sigqueue"

 -- Colin King <colin.king@canonical.com>  Mon, 23 Sep 2019 17:40:21 +0100

stress-ng (0.10.05-1) unstable; urgency=medium

  * Makefile: bump version
  * core-shim: fix typo in shim_move_mount
  * core-shim: use shim_enosys for more ENOSYS returns
  * Clean up shims for syslog(2) and syslog(3)
  * stress-ramfs: remove it from the filesystem test
  * stress-dirdeep: make inodes info into a debug message
  * Remove trailing tab from ends of lines
  * Remove trailing white space after statements
  * stress-vm: fix verification failure with gray code method
  * stress-socket: make EPIPE a non-fatal error condition
  * stress-udp: use correct default UDP port 7000
  * stress-ng: rescan the exclusion list for --class stressors
  * core-shim: reset errno before each waitpid call
  * stress-socket: handle SIGPIPE as non-fatal
  * stress-physpage: don't abort on zero address physpage
  * Use HTTPS URL for kernel.ubuntu.com

 -- Colin King <colin.king@canonical.com>  Thu, 12 Sep 2019 15:26:22 +0100

stress-ng (0.10.04-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove execute bit on bash completion script
  * debian: rules: workaround dwz failures on arm64

 -- Colin King <colin.king@canonical.com>  Mon, 2 Sep 2019 18:43:41 +0100

stress-ng (0.10.03-1) unstable; urgency=medium

  * Makefile: bump version
  * core-cache: add checks for null strings
  * stress-cpu: fix build time checks for __cpuid()
  * Debian: update compat to level 12
  * Manual: update date
  * stress-cpu: add a collatz sequence stressor
  * stress-dev: temporarily disable hpet test
  * stress-stack: use memory backed mmap'd alternative stack
  * stress-inode-flags: detect failures in pthread and propagate
    these back to parent (LP: #1841900)
  * Add a pthread return pointer to pthread args
  * stress-numa: move assignment to *node_ptr
  * core-helper: voidify return of fprintf
  * core-cache: voidify return of snprintf
  * stress-ramfs: voidify return of snprintf
  * stress-ng: voidify return of fprintf and fflush
  * core-job: voidify return of fprintf
  * core-sched: voidify return of fprintf
  * stress-get: voidify memset return
  * stress-seccomp: vodify memset return
  * stress-bind-mount: remove ` char in comment
  * stress-apparmor: remove redundant sizeof char
  * Add new 5.3 sched_attr fields, fixes EFBIG on sched_{get|set}attr
  * core-helper: don't call sched_getcpu on s390x



=== debian/control ===
Source: stress-ng
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 12), zlib1g-dev, libbsd-dev, libattr1-dev, libgcrypt20-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !linux-ia64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libipsec-mb-dev [amd64]
Homepage: https://kernel.ubuntu.com/~cking/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.

## stress-ng 0.11.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2013-2019 Canonical, Ltd.
+# Copyright (C) 2013-2020 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,9 +16,9 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.10.07
-#
-# Codename "systematic system smasher"
+VERSION=0.11.00
+#
+# Codename "synthetic system strainer"
 #
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99
@@ -43,13 +43,6 @@
 ifneq ($(NODENAME),dilos)
 GREP = /usr/xpg4/bin/grep
 endif
-endif
-
-#
-# Check for KFreeBSD
-#
-ifeq ($(KERNEL),GNU/kFreeBSD)
-CFLAGS += -D__FreeBSD_Kernel__
 endif
 
 #
@@ -109,6 +102,7 @@
 	stress-dynlib.c \
 	stress-efivar.c \
 	stress-enosys.c \
+	stress-env.c \
 	stress-epoll.c \
 	stress-eventfd.c \
 	stress-exec.c \
@@ -147,6 +141,7 @@
 	stress-iosync.c \
 	stress-ipsec-mb.c \
 	stress-itimer.c \
+	stress-judy.c \
 	stress-kcmp.c \
 	stress-key.c \
 	stress-kill.c \
@@ -168,6 +163,7 @@
 	stress-membarrier.c \
 	stress-memcpy.c \
 	stress-memfd.c \
+	stress-memhotplug.c \
 	stress-memrate.c \
 	stress-memthrash.c \
 	stress-mergesort.c \
@@ -198,6 +194,7 @@
 	stress-physpage.c \
 	stress-pidfd.c \
 	stress-pipe.c \
+	stress-pipeherd.c \
 	stress-pkey.c \
 	stress-poll.c \
 	stress-prctl.c \
@@ -242,10 +239,11 @@
 	stress-sigsegv.c \
 	stress-sigsuspend.c \
 	stress-sleep.c \
-	stress-socket.c \
-	stress-socket-diag.c \
-	stress-socket-fd.c \
-	stress-socketpair.c \
+	stress-sock.c \
+	stress-sockdiag.c \
+	stress-sockfd.c \
+	stress-sockpair.c \
+	stress-sockmany.c \
 	stress-softlockup.c \
 	stress-spawn.c \
 	stress-splice.c \
@@ -267,6 +265,7 @@
 	stress-tree.c \
 	stress-tsc.c \
 	stress-tsearch.c \
+	stress-tun.c \
 	stress-udp.c \
 	stress-udp-flood.c \
 	stress-unshare.c \
@@ -284,6 +283,7 @@
 	stress-wait.c \
 	stress-watchdog.c \
 	stress-wcstr.c \
+	stress-x86syscall.c \
 	stress-xattr.c \
 	stress-yield.c \
 	stress-zero.c \
@@ -297,6 +297,7 @@
 	core-affinity.c \
 	core-cache.c \
 	core-cpu.c \
+	core-hash.c \
 	core-helper.c \
 	core-ignite-cpu.c \
 	core-io-priority.c \
@@ -319,6 +320,7 @@
 	core-thermal-zone.c \
 	core-time.c \
 	core-thrash.c \
+	core-try-open.c \
 	stress-ng.c
 
 SRC = $(STRESS_SRC) $(CORE_SRC)
@@ -416,10 +418,10 @@
 	mkdir stress-ng-$(VERSION)
 	cp -rp Makefile Makefile.config $(SRC) stress-ng.h stress-ng.1 \
 		core-personality.c COPYING syscalls.txt mascot README \
-		README.Android test snap config TODO \
-		core-perf-event.c usr.bin.pulseaudio.eg stress-version.h \
-		bash-completion example-jobs .travis.yml kernel-coverage.sh \
-		stress-ng-$(VERSION)
+		stress-af-alg-defconfigs.h README.Android test snap config \
+		TODO core-perf-event.c usr.bin.pulseaudio.eg \
+		stress-version.h bash-completion example-jobs .travis.yml \
+		kernel-coverage.sh stress-ng-$(VERSION)
 	tar -Jcf stress-ng-$(VERSION).tar.xz stress-ng-$(VERSION)
 	rm -rf stress-ng-$(VERSION)

=== debian/changelog ===
stress-ng (0.11.00-1) unstable; urgency=medium

  * Makefile: bump version and change codename
  * stress-pipeherd: make sure child terminates with _exit()
  * kernel-coverage: add timer-slack timer setting
  * Fix --timer-slack correctly, fetch argument and set it
  * core-parse-opts: sanity check uint32 and int32 min/max values
  * Add environment stressor
  * Make several const objects static
  * stress-pidfd: voidify return from pause system call
  * stress-get: add missing check_do_run exit points after new get*
    system calls
  * stress-get: exercise a few more get* system calls
  * stress-pipeherd: add context switch stats
  * Add pipeherd stressor: a stress to simulate a thundering herd of
    pipe wakeups

 -- Colin King <colin.king@canonical.com>  Wed, 12 Feb 2020 14:19:41 +0000

stress-ng (0.10.19-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-mmapaddr: make stress_mmapaddr_child static
  * stress-wait: remove duplicated pr_fail message and cast pid_t to
    long int
  * stress-memrate: rename NANOSEC to STRESS_NANOSEC to avoid clashing
  * stress-cyclic: avoid NANOSEC* name classhes, rename to STRESS_NANOSEC
  * Fix the MAX_FILE_LIMIT shift, use 1ULL instead of 1UL
  * stress-sockfd: attempt to read from the fd passed over the socket
  * stress-fork: fix time_now calls to stress_time_now
  * stress-clone: move a #if defined that got moved to the wrong place
  * set maximum file size based on off_t size
  * set maximum memory limit to MAX_48 and maximized limits to MAX_32
  * core-sched: prefix typedefs with stress_
  * core-perf: prefix typedefs with stress_
  * core-net: prefix typedefs with stress_
  * core-ignite-cpu: prefix typedefs with stress_
  * core-cache: prefix typedefs with stress_
  * core-cache: prefix typedefs with stress_
  * stress-*: prefix typedefs with stress_
  * stress-pty: allocate the pty structure on the heap, don't use the
    stack
  * stress-stackmmap: ensure random data is pushed onto the stack
  * stress-stack: fill pages with non-zero content to avoid same-page
    merges
  * stress-spawn: fix up a comment
  * stress-wait: add waitid siginfo sanity checks
  * stress-wait: fix WIFCONTINUED check because of a typo in the check
  * core-helper: map signal number to signal name
  * core-shim: fix renaming of time_now to stress_time_now
  * core-helper: voidify arg fd in stress_is_dev_tty
  * stress-x86syscall: move scope of variable j
  * stress-vdso: measure test overhead to compute more accurate results
  * stress-x86syscall: measure test overhead to compute more accurate
    results
  * core-time: prefix helper functions with stress_
  * core-thrash: prefix helper functions with stress_
  * core-thermal-zone: prefix helper functions with stress_
  * core-perf: prefix perf helper functions with stress_
  * core-mount: add stress_ to mount helper functions
  * Add stress_ to mmap_set and mmap_check helper functions
  * Prefix mincore helper functions with stress_
  * Rename madvise_random to stress_madvise_random
  * stress-zlib: scale the logmap value to produce harder to compress
    data
  * stress-zlib: add chaotic number generator using a logmap method
  * replace g_keep_stressing_flag with two helper functions
  * stress-memthrash: add byte swapping memory stepping thrasher
  * stress-sysfs: add bad sysfs files to hash table
  * Makefile: remove need to define __FreeBSD_Kernel__
  * Add more stress_ prefixes to various core functions
  * core-ignite-cpu: prefix ignite_* functions with stress_
  * core-cpu: rename cpu_is_x86 to stress_cpu_is_x86
  * core-hash: remove need for str pointer
  * core-hash: optimize hash adding, reduce need for strdup and a free
  * stress-zombie: make max zombies a 32 bit
  * stress-clone: make max clones a 32 bit
  * stress-chdir: cleanup the chdir(cwd) loop
  * stress-memrate: clean up continuation lines
  * Rename set_oom_adjustment -> stress_set_oom_adjustment
  * Add stress_oomable_child helper to catch and restart OOM'd child
    processes
  * stress-chdir: use flags rather than #ifdef around the open call
  * core-hash: move various string hashing functions to core-hash

 -- Colin King <colin.king@canonical.com>  Fri, 7 Feb 2020 14:37:11 +0000

stress-ng (0.10.18-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-urandom: handle ENOTTY errors on ioctl() on older kernels

 -- Colin King <colin.king@canonical.com>  Wed, 29 Jan 2020 14:09:22 +0000

stress-ng (0.10.17-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-clock: reduce scope of variable ret
  * stress-shm: free addrs and shm_names on error
  * stress-shm: only use SA_NOCLDWAIT if it is available
  * stress-exec: clean up warning on gcc 4.8.5
  * stress-exec: define err label only if required
  * Add core-try-open helper to check if a file can be opened without
    blocking
  * stress-exec: remove shadowed variables ret and rc
  * Add string hash helper to core, use this for device and scsi hashing
  * stress-dev: move handler to fix build warning
  * stress-dev: fix equality checks and incorrect stress_dev_tty_open
    call
  * stress-dev: add blocked device open sanity check
  * stress-cpu: add lowest common multiple sanity check on gcd
    computation
  * stress-clock: exercise clock_getres on a /dev/ptp0 clockid
  * stress-clock: exercise /dev/ptp0 on linux
  * kernel-coverage.sh: allow perf to run when non-root
  * stress-tmpfs: add MAP_HUGETLB mmap option and reduce sleep time
  * stress-mmap: remove duplicated no_mem_retries increment
  * stress-membarrier: exercise more membarrier commands
  * stress-fcntl: exercise F_SETOWN, F_SETOWN_EX and F_GETOWN_EX more
  * stress-exec: create and try to execute a garbage executable
  * stress-stream: fix failure message logging
  * stress-shm: add some more shm exercising on shm fd
  * stress-ramfs: rename mount point directory to mnt
  * stress-af-alg: add helpers to lookup hash types by name or type
  * stress-af-alg: remove ptr + 2 occurrences


=== debian/control ===
Source: stress-ng
Section: devel
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 12), zlib1g-dev, libbsd-dev, libattr1-dev, libgcrypt20-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !linux-ia64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libipsec-mb-dev [amd64], libjudy-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
Homepage: https://kernel.ubuntu.com/~cking/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.

## stress-ng 0.11.07

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.11.00
+VERSION=0.11.07
 #
 # Codename "synthetic system strainer"
 #
@@ -72,11 +72,13 @@
 	stress-bad-altstack.c \
 	stress-bigheap.c \
 	stress-bind-mount.c \
+	stress-binderfs.c \
 	stress-branch.c \
 	stress-brk.c \
 	stress-bsearch.c \
 	stress-cache.c \
 	stress-cap.c \
+	stress-chattr.c \
 	stress-chdir.c \
 	stress-chmod.c \
 	stress-chown.c \
@@ -210,6 +212,7 @@
 	stress-rawsock.c \
 	stress-rdrand.c \
 	stress-readahead.c \
+	stress-reboot.c \
 	stress-remap-file-pages.c \
 	stress-rename.c \
 	stress-resources.c \
@@ -238,8 +241,10 @@
 	stress-sigrt.c \
 	stress-sigsegv.c \
 	stress-sigsuspend.c \
+	stress-skiplist.c \
 	stress-sleep.c \
 	stress-sock.c \
+	stress-sockabuse.c \
 	stress-sockdiag.c \
 	stress-sockfd.c \
 	stress-sockpair.c \

=== debian/changelog ===
stress-ng (0.11.07-1ubuntu2) focal; urgency=medium

  * stress-hdd: ensure offset is aligned to 512 byte boundary (LP: #1951152)
    fixes direct I/O random write failures with the hdd stressor

 -- Colin Ian King <colin.i.king@gmail.com>  Tue, 16 Nov 2021 19:31:29 +0000

stress-ng (0.11.07-1ubuntu1) focal; urgency=medium

  * Quote the system-info.version value in YAML metrics (LP: #1943623)
   - upstream commit a52f236917f5 ("core-helper: Quote the
     system-info.version value in YAML metrics")
    
 -- Colin King <colin.king@canonical.com>  Tue, 14 Sep 2021 18:08:14 +0100

stress-ng (0.11.07-1) unstable; urgency=medium

  * Address multiple issues found with pedantic static analysis (LP: #1870193)
    - enabled higher static analysis settings and found and fixed
      a lot of bugs..
  * Makefile: bump version
  * Manual: fix lintian warning on undefined macro
  * stress-zlib: fix clang warning of array subscripted by char
  * core-helper: make end-of-string assignment easier to comprehend
  * stress-reboot: use heap for clone stack, cleans up static analysis warning
  * core-cache: clean up pedantic warnings from static analysis
  * stress-af-alg: fix several memory leaks
  * stress-tun: fix close issues on sfd
  * stress-xattr: be overly pedantic and memset array tmp
  * stress-urandom: fix fd leak on fd_rnd_wr
  * stress-sysbadaddr: fix incorrect 2nd parameter to utimes call
  * stress-sockmany: fix fd leak, close file descriptor on error
  * stress-sockabuse: ensure addrlen is set to the length of addr
  * stress-sockabuse: close fd even when it is zero
  * stress-sockabuse: avoid closing unopened fd on error
  * stress-sock: ensure socklen setting is set before calling getsockopt
  * stress-sigfd: voidify return of read, we don't care if it fails
  * stress-sigfd: fix open error check
  * stress-shm: use shim helper and ignore error return
  * stress-ramfs: fix close of a -ve file descriptor
  * stress-pipeherd: remove redundant variable n
  * stress-mq: don't check values[prio] if prio is out of range
  * stress-memhotplug: fix leak of opendir descriptor
  * stress-judy: check allocated pvalue is not-null
  * stress-eventfd: fix incorrect open failure check
  * stress-cpu: gcd: fix potential multiply overflow
  * stress-cpu: ensure i64 is stashed in stress_cpu_intconversion
  * stress-clock: be extra pedantic and set and check timer_id values
  * stress-chattr: handle open failure correctly
  * stress-binderfs: fix failure error return path
  * stress-af-alg: fix incorrect size of buffer to randomize
  * core-helper: don't call ttyname a second time, use name instead
  * core-helper: ensure data is null terminated
  * core-cache: nullify a free'd cpus pointer before returning
  * stress-cpu: add missing Apéry constant cpu method
  * stress-zlib: add missing morse code generated text

 -- Colin King <colin.king@canonical.com>  Wed, 1 Apr 2020 18:23:41 +0100

stress-ng (0.11.06-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-dev: remove TIOCGETC and TIOCSETC ioctl to fix FTBFS on alpha
    - this is the 2nd attempt to fix this issue, this time I'm removing
      the use these specific ioctl commands.

 -- Colin King <colin.king@canonical.com>  Mon, 30 Mar 2020 09:46:35 +0100

stress-ng (0.11.05-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-dev: define a shim for struct tchar, fixes a FTBFS
    on arch alpha

 -- Colin King <colin.king@canonical.com>  Sun, 29 Mar 2020 17:34:14 +0100

stress-ng (0.11.04-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-sockabuse: reduce scope of variable sfd
  * stress-reboot: reduce scope of another ret variable
  * stress-reboot: reduce scope of variable ret
  * stress-skiplist: make function skip_list_free static
  * stress-madvise: relax constness of buf pointer
  * stress-reboot: don't pass args to clone, it is not required
  * stress-reboot: remove shadowed variable ret
  * stress-sysbaddr: add guard on bad_getdomainname and comment
    out bad_acct
  * stress-sysbadaddr: disable acct for the moment.
  * stress-sysbadaddr: limit clone to just linux for the moment
  * stress-sysbadaddr: pass incremented addresses to avoid restrict
    warnings
  * stress-sysinfo: cast void * to the appropriate arg types on system
    calls
  * stress-reboot: add and use SHIM_CAP_SYS_BOOT
  * stress-reboot: move help so it's always built in
  * Add a reboot stressor.  This does not actually reboot a system.
  * stress-sigfd: exercise the fd info of the signalfd
  * stress-fcntl: pass uids array to fcntl for F_GETOWNER_UIDS cmd
  * stress-sysbadaddr: remove create, it can leave broken files in
    directory
  * stress-sysbadaddr: add in more system calls
  * stress-procfs: remove ARM64 workaround as this is now fixed
  * README: update stressor stats
  * stress-xattr: don't fail to build if HAVE_LGETXATTR is not defined
  * stress-xattr: don't fail to build if HAVE_LSETXATTR is not defined
  * stress-xattr: don't fail to build if HAVE_LLISTXATTR is not defined
  * core-shim: fix typo on LLISTXATTR detection
  * Add shims to xattr system calls
  * stress-pipeherd: fix typo in switch rate info
  * stress-sockabuse: remove xattr from OS X builds
  * stress-dev: add TCOOFF, TCOON, TCIOFF, TCION ioctls
  * stress-dev: add TIOCGETC and TIOCSETC ioctls
  * stress-rtc: exercise RTC_SET_TIME, RTC_IRQP_SET and RTC_VL_READ
    ioctls
  * stress-ustat: silently ignore bad ustat buf
  * stress-sockabuse: don't memset timespec if we don't have
    HAVE_FUTIMENS
  * stress-sockabuse: silently ignore EADDRINUSE error when binding
  * stress-sockabuse: use different port for each instance
  * stress-sockabuse: use DEFAULT_SOCKABUSE_PORT as the default post
  * stress-ng.h: update a couple of socket port definitions
  * core-shim: cast shim'd ustat arg to void *
  * stress-sockabuse: localize variable n to FIONREAD ioctl code block
  * core-shim: fix missing ; on shim_enosys call
  * Add a skiplist stressor


=== debian/control ===
Source: stress-ng
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 12), zlib1g-dev, libbsd-dev, libgcrypt20-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !linux-ia64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libipsec-mb-dev [amd64], libjudy-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
Homepage: https://kernel.ubuntu.com/~cking/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); dh_auto_build

override_dh_dwz:

%:
	dh $@

=== debian/watch ===
version=3
https://kernel.ubuntu.com/~cking/tarballs/stress-ng/stress-ng-(.+).tar.xz

## stress-ng 0.11.21

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.11.07
+VERSION=0.11.21
 #
 # Codename "synthetic system strainer"
 #
@@ -70,6 +70,7 @@
 	stress-apparmor.c \
 	stress-atomic.c \
 	stress-bad-altstack.c \
+	stress-bad-ioctl.c \
 	stress-bigheap.c \
 	stress-bind-mount.c \
 	stress-binderfs.c \
@@ -141,6 +142,7 @@
 	stress-ioport.c \
 	stress-ioprio.c \
 	stress-iosync.c \
+	stress-io-uring.c \
 	stress-ipsec-mb.c \
 	stress-itimer.c \
 	stress-judy.c \
@@ -182,6 +184,7 @@
 	stress-msg.c \
 	stress-msync.c \
 	stress-mq.c \
+	stress-nanosleep.c \
 	stress-netdev.c \
 	stress-netlink-proc.c \
 	stress-netlink-task.c \
@@ -209,7 +212,9 @@
 	stress-radixsort.c \
 	stress-ramfs.c \
 	stress-rawdev.c \
+	stress-rawpkt.c \
 	stress-rawsock.c \
+	stress-rawudp.c \
 	stress-rdrand.c \
 	stress-readahead.c \
 	stress-reboot.c \
@@ -228,10 +233,13 @@
 	stress-sem.c \
 	stress-sem-sysv.c \
 	stress-sendfile.c \
+	stress-session.c \
 	stress-set.c \
 	stress-shellsort.c \
 	stress-shm.c \
 	stress-shm-sysv.c \
+	stress-sigabrt.c \
+	stress-sigchld.c \
 	stress-sigfd.c \
 	stress-sigfpe.c \
 	stress-sigio.c \
@@ -241,6 +249,7 @@
 	stress-sigrt.c \
 	stress-sigsegv.c \
 	stress-sigsuspend.c \
+	stress-sigtrap.c \
 	stress-skiplist.c \
 	stress-sleep.c \
 	stress-sock.c \
@@ -261,6 +270,7 @@
 	stress-sync-file.c \
 	stress-sysbadaddr.c \
 	stress-sysinfo.c \
+	stress-sysinval.c \
 	stress-sysfs.c \
 	stress-tee.c \
 	stress-timer.c \
@@ -325,23 +335,18 @@
 	core-thermal-zone.c \
 	core-time.c \
 	core-thrash.c \
+	core-ftrace.c \
 	core-try-open.c \
 	stress-ng.c
 
-SRC = $(STRESS_SRC) $(CORE_SRC)
+SRC = $(CORE_SRC) $(STRESS_SRC)
 OBJS = $(SRC:.c=.o)
 
 APPARMOR_PARSER=/sbin/apparmor_parser
 
-LIB_APPARMOR := -lapparmor
-LIB_BSD := -lbsd
-LIB_Z := -lz
-LIB_CRYPT := -lcrypt
-LIB_RT := -lrt
-LIB_PTHREAD := -lpthread
-LIB_AIO = -laio
-LIB_SCTP = -lsctp
-LIB_DL = -ldl
+all:
+	$(MAKE) makeconfig -j1 
+	$(MAKE) stress-ng
 
 #
 #  Load in and set flags based on config
@@ -351,17 +356,11 @@
 LDFLAGS += $(CONFIG_LDFLAGS)
 OBJS += $(CONFIG_OBJS)
 
-all:
-ifneq ("$(wildcard config)","")
-	$(MAKE) makeconfig
-endif
-	$(MAKE) stress-ng
-
 .SUFFIXES: .c .o
 
 .o: stress-ng.h Makefile
 
-.c.o: stress-ng.h Makefile $(SRC)
+.c.o:
 	@echo "CC $<"
 	@$(CC) $(CFLAGS) -c -o $@ $<
 
@@ -371,7 +370,7 @@
 	@sync
 
 makeconfig:
-	@if [ ! -s config ]; then \
+	@if [ ! -e config ]; then \
 		STATIC=$(STATIC) $(MAKE) -f Makefile.config; \
 	fi
 
@@ -396,13 +395,26 @@
 #  extract the PER_* personality enums
 #
 personality.h:
-	@$(CPP) core-personality.c | $(GREP) -e "PER_[A-Z0-9]* =.*," | cut -d "=" -f 1 \
+	@$(CPP) $(CONFIG_CFLAGS) core-personality.c | $(GREP) -e "PER_[A-Z0-9]* =.*," | cut -d "=" -f 1 \
 	| sed "s/.$$/,/" > personality.h
+	@echo "MK personality.h"
 
 stress-personality.c: personality.h
 
+#
+#  extract IORING_OP enums and #define HAVE_ prefixed values
+#  so we can check if these enums exist
+#
+io-uring.h:
+	@$(CPP) $(CONFIG_CLFAGS) core-io-uring.c  | grep IORING_OP | sed 's/,//' | \
+	sed 's/IORING_OP_/#define HAVE_IORING_OP_/' > io-uring.h
+	@echo "MK io-uring.h"
+
+stress-io-uring.c: io-uring.h
+
 core-perf.o: core-perf.c core-perf-event.c
-	@$(CC) $(CFLAGS) -E core-perf-event.c | grep "PERF_COUNT" | sed 's/,/ /' | \
+	@$(CC) $(CFLAGS) -E core-perf-event.c | grep "PERF_COUNT" | \
+	sed 's/,/ /' | sed s/'^ *//' | \
 	awk {'print "#define _SNG_" $$1 " (1)"'} > core-perf-event.h
 	@echo CC $<
 	@$(CC) $(CFLAGS) -c -o $@ $<
@@ -422,11 +434,12 @@
 	rm -rf stress-ng-$(VERSION)
 	mkdir stress-ng-$(VERSION)
 	cp -rp Makefile Makefile.config $(SRC) stress-ng.h stress-ng.1 \
-		core-personality.c COPYING syscalls.txt mascot README \
-		stress-af-alg-defconfigs.h README.Android test snap config \
+		core-personality.c core-io-uring.c \
+		COPYING syscalls.txt mascot README \
+		stress-af-alg-defconfigs.h README.Android test snap \
 		TODO core-perf-event.c usr.bin.pulseaudio.eg \
 		stress-version.h bash-completion example-jobs .travis.yml \
-		kernel-coverage.sh stress-ng-$(VERSION)
+		kernel-coverage.sh code-of-conduct.txt stress-ng-$(VERSION)
 	tar -Jcf stress-ng-$(VERSION).tar.xz stress-ng-$(VERSION)
 	rm -rf stress-ng-$(VERSION)
 
@@ -440,14 +453,19 @@
 	@rm -f stress-ng $(OBJS) stress-ng.1.gz stress-ng.pdf
 	@rm -f stress-ng-$(VERSION).tar.xz
 	@rm -f personality.h
+	@rm -f io-uring.h
 	@rm -f perf-event.h
 	@rm -f apparmor-data.bin
 	@rm -f *.o
-	@:> config
+	@rm -f config
 
 .PHONY: fast-test-all
 fast-test-all: all
 	STRESS_NG=./stress-ng debian/tests/fast-test-all
+
+.PHONY: lite-test
+lite-test: all
+	STRESS_NG=./stress-ng debian/tests/lite-test
 
 .PHONY: slow-test-all
 slow-test-all: all

=== debian/changelog ===
stress-ng (0.11.21-1) unstable; urgency=medium

  [Colin Ian King]
  * Makefile: bump version
  * Manual: update date
  * stress-unshare: don't report ENOSPC as a failure in the unshare
  * Makefile: remove personality info, it is distracting
  * stress-clock: fix build warnings BSD systems
  * Makefile: remove -DHAVE_LINUX_IO_URING_H, it was included for testing
  * stress-dev: fix build warnings on non-Linux platforms
  * stress-dev: fix build error on non-linux systems with Xen guest
    checking
  * README: update number of stress tests
  * stress-dirdeep: add post recursion yield point check
  * stress-io-uring: add built-time checking for io-uring opcode enums
  * Makefile: provide personality build information
  * Makefile: make core first to keep order alphabetic
  * stress-io-uring: exercise NOP and FSYNC IO opcodes
  * stress-sysfs: skip over gcov sysfs debug files
  * stress-dirdeep: declare dirfd when HAVE_LINKAT is also defined
  * stress-dirdeep: exercise linkat in a few different ways
  * stress-clock: add build time check for TIMER_ABSTIME
  * core-helper: use shim strl* functions
  * stress-eventfd: remove { } for one line block statement
  * stress-eventfd: perform illegal writes periodically
  * stress-unshare: add in missing empty line
  * stress-io-uring: reap resources at end of test, exercise fdinfo
  * stress-io-uring: remove CLASS_INTERRUPT from stressor classes
  * Add stress_mk_filename to make a filename from full path and name
  * stress-inotify: fix build warning
  * io-uring: fix help, it was cut-n-pasted from io async stressor
  * Add io-uring stressor to exercise io-uring system calls
  * stress-inotify: some minor code style changes, no functional changes
  * stress-inotify: optimization: get bad fd just once
  * stress-inotify: fix build failures on systems without IN_MASK_CREATE
    and IN_MASK_ADD
  * stress-shm-sysv: exercise SYSV namespace objects
  * stress-sem-sysv: remove busy loop, replace it with pause
  * stress-sem: remove busy loop, replace it with pause
  * stress-fanotify: fix build warning on declaration of bad_fd
  * stress-fanotify: fix build failure with systems where FAN_MARK_INODE
    is not defined
  * stress-fanotify: fix name shadowing on function parameter mnts
  * stress-timerfd: fix shadowing of variable ret
  * stress-close: fix variable shadowing of ret
  * stress-dev: add some device timeouts on slow optical devices
  * stress-fallocate: remove some whitespaces/lines
  * stress-fallocate: exercise illegal offset and lengths
  * stress-fallocate: exercise illegal fallocate on a pipe
  * stress-fallocate: add a blank line
  * stress-fallocate: exercise some illegal modes
  * stress-dev: allow hpet checking if not a Xen guest
  * stress-timerfd: fix check of CLOCK_REALTIME_ALARM

  [Piyush Goyal]
  * stress-schedpolicy: exercise invalid sched_getattr syscalls
  * stress-timer:exercise nanosleep on invalid timespec
  * stress-clock: exercise clock_nanosleep on invalid timespec
  * stress-clock: Exercise clock_nanosleep on invalid clock id
  * stress-clock: exercise clock_adjtime on invalid clock id
  * stress-eventfd: exercise illegal writes on event fd
  * stress-eventfd: initialise the value written in event fd
  * stress-eventfd: read from event fd on a small buffer
  * stress-eventfd: exercise eventfd with invalid flags
  * Makefile.config: add build time check for epoll_create
  * stress-inotify: exercise inotify_rm_watch on non-inotify fd
  * stress-inotify: exercise inotify_rm_watch on invalid wd
  * stress-inotify: exercise inotify_rm_watch on bad fd
  * stress-inotify: Exercise inotify_add_watch on bad_fd
  * stress-inotify: exercise inotify_add_watch on already existing fd
  * stress-inotify: exercise inotify_add_watch with two operations
  * stress-inotify: exercise inotify_add_watch with bad mask
  * stress-inotify: exercise invalid inotify_init1
  * syscalls.txt: add inotify_init syscall
  * stress-inotify: add syscall inotify1 and exercise it
  * stress-fanotify: exercise invalid combination of flags
  * stress-fanotify: add build time check for FAN_MARK_MOUNT
  * stress-fanotify: Add fanotify syscalls
  * stress-fanotify: Add test for fanotify_mark syscall
  * stress-fanotify: Exercise fanotify_mark on bad fd
  * stress-fanotify: Exercise fanotify_mark with invalid flag
  * stress-fanotify: add test_fanotify_mark
  * stress-fanotify: Exercise fanotify_init syscalls with different flags
  * stress-fanotify: Add fanotify_init syscalls
  * stress-timerfd: Exercise timerfd_settime with invalid flags
  * stress-timerfd: Exercise non valid timerfd file descriptor

 -- Colin King <colin.king@canonical.com>  Wed, 16 Sep 2020 22:58:21 +0100

stress-ng (0.11.20-1) unstable; urgency=medium

  [André Wild]
  * Fix error if only HAVE_TERMIOS is not set
  * stress-zlib: Fixes race conditions during deflate/inflate
  * stress-ipsec-mb: Fixes out of bounds access of unterminated funcs
    array
  * stress-zlib: new zlib stressor options

  [Colin Ian King]
  * Makefile: bump version
  * stress-zlib: cast pid_t to int for %d format specifier
  * stress-timerfd: only define cap_wake_alarm when it is required
  * stress-open: cast pid_t to int for %d format specifier
  * stress-timerfd: add build checks for CLOCK_REALTIME_* timers
  * stress-memthrash: fix premature termination by OOM handler
  * stress-memthrash: fix typo in comment "Wait" -> "Wake"
  * stress-zlib: use %zd for ssize_t, fixes build warning on GNU/HURD
  * stress-vforkmany: improve waiting by terminating child
  * stress-open: fix build failures on systems that don't support O_PATH
  * stress-close: add directory clean up at end
  * stress-affinity: use 16 processes to hammer affinity changes per
    stressor
  * stress-af-alg: break some overly long lines
  * stress-af-alg: add string overflow sanity check
  * stress-access: break wide defined() checks to 2 lines
  * stress-madvise: make signal message text plural on > 1 SIGBUS signals
